#include "stdafx.h"
#include "R3DBrain.h"

DWORD GetFileSize(LPCTSTR FileName)
{
	HANDLE hFile;
	DWORD dw;
	hFile = CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
		return 0;
	dw = GetFileSize(hFile, NULL);
	CloseHandle(hFile);
	return dw;
}

BOOL LoadFile(LPCTSTR FileName, void* pData, DWORD dwSize)
{
	HANDLE hFile;
	DWORD dw;
	hFile = CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
		return FALSE;
	ReadFile(hFile, pData, dwSize, &dw, NULL);
	CloseHandle(hFile);
	if(dw != dwSize)
		return FALSE;
	return TRUE;
}

BOOL SaveFile(LPCTSTR FileName, void* pData, DWORD dwSize)
{
	HANDLE hFile;
	DWORD dw;
	hFile = CreateFile(FileName, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
		return FALSE;
	WriteFile(hFile, pData, dwSize, &dw, NULL);
	CloseHandle(hFile);
	if(dw != dwSize)
		return FALSE;
	return TRUE;
}

#define RGB565(r, g, b)					((PIXEL565)(((r >> 3) << 11) | ((g >> 2) << 5) | (b >> 3)))

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	LONG i;
	LONG j;
	TCHAR* p;
	TCHAR Temp[MAX_PATH];
	TCHAR AppDir[MAX_PATH];
	WNDCLASS Class;
	HWND hWnd;
	HDC hDestDC;
	HDC hSrcDC;
	BITMAP_SHARP_BRAIN Buffer;
	BITMAPZ16 ZBuffer;
	BITMAP_SHARP_BRAIN Texture[2];
	PIXEL565 ColorKey;
	VERTEX_XYZWUV* pVertex;
	DWORD VertexCount;
	DWORD* pIndex;
	DWORD IndexCount;
	VERTEX_XYZWUV* pVertexBuffer;
	MATRIX_XYZW Matrix[3];
	DWORD Time[4][2];
	HGDIOBJ hOld;
	GetModuleFileName(NULL, AppDir, MAX_PATH - 1);
	p = _tcsrchr(AppDir, _T('\\'));
	if(p)
		*p = _T('\0');
	ZeroMemory(&Class, sizeof(WNDCLASS));
	Class.style = CS_HREDRAW | CS_VREDRAW;
	Class.lpfnWndProc = DefWindowProc;
	Class.hInstance = hInstance;
	Class.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	Class.lpszClassName = _T("SHARP Brain Software 3D Test");
	RegisterClass(&Class);
	hWnd = CreateWindowEx(0, Class.lpszClassName, _T("Main"), WS_POPUP, 0, 0, 256, 256, NULL, NULL, NULL, NULL);
	ShowWindow(hWnd, SW_SHOW);
	UpdateWindow(hWnd);
	hDestDC = GetDC(hWnd);
	hSrcDC = CreateCompatibleDC(hDestDC);
	CreateBitmapSharpBrain(&Buffer, 256, 256);
	CreateBitmap16Any(&ZBuffer, 256, 256);
	CreateBitmapSharpBrain(&Texture[0], 256, 256);
	CreateBitmapSharpBrain(&Texture[1], 256, 256);
	ColorKey = RGB565(0, 255, 0);
	_stprintf(Temp, _T("%s\\vertex.dat"), AppDir);
	VertexCount = GetFileSize(Temp) / sizeof(VERTEX_XYZWUV);
	pVertex = new VERTEX_XYZWUV[VertexCount];
	LoadFile(Temp, pVertex, sizeof(VERTEX_XYZWUV) * VertexCount);
	_stprintf(Temp, _T("%s\\index.dat"), AppDir);
	IndexCount = GetFileSize(Temp) / (sizeof(DWORD) * 3);
	pIndex = new DWORD[IndexCount * 3];
	LoadFile(Temp, pIndex, sizeof(DWORD) * IndexCount * 3);
	pVertexBuffer = new VERTEX_XYZWUV[VertexCount];
	_stprintf(Temp, _T("%s\\title.dat"), AppDir);
	LoadFile(Temp, Texture[0].Bitmap.pBitmap, sizeof(PIXEL565) * Texture[0].Bitmap.Width * Texture[0].Bitmap.Height);
	_stprintf(Temp, _T("%s\\texture.dat"), AppDir);
	LoadFile(Temp, Texture[1].Bitmap.pBitmap, sizeof(PIXEL565) * Texture[1].Bitmap.Width * Texture[1].Bitmap.Height);
	pVertexBuffer[0].x = LONG_TO_SCALAR32(0);
	pVertexBuffer[0].y = LONG_TO_SCALAR32(0);
	pVertexBuffer[0].z = LONG_TO_SCALAR32(0);
	pVertexBuffer[0].w = SCALAR32_UNIT;
	pVertexBuffer[0].u = LONG_TO_SCALAR32(0);
	pVertexBuffer[0].v = LONG_TO_SCALAR32(0);
	pVertexBuffer[1].x = LONG_TO_SCALAR32(256);
	pVertexBuffer[1].y = LONG_TO_SCALAR32(0);
	pVertexBuffer[1].z = LONG_TO_SCALAR32(0);
	pVertexBuffer[1].w = SCALAR32_UNIT;
	pVertexBuffer[1].u = LONG_TO_SCALAR32(256);
	pVertexBuffer[1].v = LONG_TO_SCALAR32(0);
	pVertexBuffer[2].x = LONG_TO_SCALAR32(0);
	pVertexBuffer[2].y = LONG_TO_SCALAR32(256);
	pVertexBuffer[2].z = LONG_TO_SCALAR32(0);
	pVertexBuffer[2].w = SCALAR32_UNIT;
	pVertexBuffer[2].u = LONG_TO_SCALAR32(0);
	pVertexBuffer[2].v = LONG_TO_SCALAR32(256);
	pVertexBuffer[3].x = LONG_TO_SCALAR32(256);
	pVertexBuffer[3].y = LONG_TO_SCALAR32(256);
	pVertexBuffer[3].z = LONG_TO_SCALAR32(0);
	pVertexBuffer[3].w = SCALAR32_UNIT;
	pVertexBuffer[3].u = LONG_TO_SCALAR32(256);
	pVertexBuffer[3].v = LONG_TO_SCALAR32(256);
	Sleep(1000);
	Time[0][0] = timeGetTime();
	for(i = 0; i < 50; i++)
	{
		ZeroMemory(Buffer.Bitmap.pBitmap, sizeof(PIXEL565) * Buffer.Bitmap.Width * Buffer.Bitmap.Height);
		DrawVertexArrayXYZWUV(&Buffer.Bitmap, NULL, &Texture[0].Bitmap, pVertexBuffer, 4, VERTEX_CULL_NONE, NULL);
		hOld = SelectObject(hSrcDC, Buffer.hBitmap);
		BitBlt(hDestDC, 0, 0, Buffer.Bitmap.Width, Buffer.Bitmap.Height, hSrcDC, 0, 0, SRCCOPY);
		SelectObject(hSrcDC, hOld);
	}
	Time[0][1] = timeGetTime();
	Sleep(1000);
	Time[1][0] = timeGetTime();
	for(i = 0; i < 100; i++)
	{
		hOld = SelectObject(hSrcDC, Buffer.hBitmap);
		BitBlt(hDestDC, 0, 0, Buffer.Bitmap.Width, Buffer.Bitmap.Height, hSrcDC, 0, 0, SRCCOPY);
		SelectObject(hSrcDC, hOld);
	}
	Time[1][1] = timeGetTime();
	Sleep(1000);
	Time[2][0] = timeGetTime();
	for(i = 0; i < 100; i++)
	{
		pVertexBuffer[0].x = LONG_TO_SCALAR32(128) * i / 100;
		pVertexBuffer[0].y = LONG_TO_SCALAR32(128) * i / 100;
		pVertexBuffer[1].x = LONG_TO_SCALAR32(256) - LONG_TO_SCALAR32(128) * i / 100;
		pVertexBuffer[1].y = LONG_TO_SCALAR32(128) * i / 100;
		pVertexBuffer[2].x = LONG_TO_SCALAR32(128) * i / 100;
		pVertexBuffer[2].y = LONG_TO_SCALAR32(256) - LONG_TO_SCALAR32(128) * i / 100;
		pVertexBuffer[3].x = LONG_TO_SCALAR32(256) - LONG_TO_SCALAR32(128) * i / 100;
		pVertexBuffer[3].y = LONG_TO_SCALAR32(256) - LONG_TO_SCALAR32(128) * i / 100;
		ZeroMemory(Buffer.Bitmap.pBitmap, sizeof(PIXEL565) * Buffer.Bitmap.Width * Buffer.Bitmap.Height);
		DrawVertexArrayXYZWUV(&Buffer.Bitmap, NULL, &Texture[0].Bitmap, pVertexBuffer, 4, VERTEX_CULL_NONE, NULL);
		hOld = SelectObject(hSrcDC, Buffer.hBitmap);
		BitBlt(hDestDC, 0, 0, Buffer.Bitmap.Width, Buffer.Bitmap.Height, hSrcDC, 0, 0, SRCCOPY);
		SelectObject(hSrcDC, hOld);
	}
	Time[2][1] = timeGetTime();
	Sleep(1000);
	Time[3][0] = timeGetTime();
	for(i = 0; i < 100; i++)
	{
		ZeroMemory(Buffer.Bitmap.pBitmap, sizeof(PIXEL565) * Buffer.Bitmap.Width * Buffer.Bitmap.Height);
		for(j = 0; j < (LONG)ZBuffer.Width * ZBuffer.Height; j++)
			ZBuffer.pBitmap[j] = 0xffff;
		Matrix[0] = GetRotateYMatrix(SCALAR32_PI * i / 50);
		Matrix[1] = GetMoveMatrix(0, LONG_TO_SCALAR32(4), LONG_TO_SCALAR32(80) - SCALAR32_UNIT * i / 4);
		Matrix[2] = GetViewAngleMatrix(SCALAR32_UNIT / 4, 256, 256, LONG_TO_SCALAR32(32), LONG_TO_SCALAR32(160));
		for(j = 0; j < (LONG)VertexCount; j++)
		{
			pVertexBuffer[j] = MultiplyMatrixVertex(&Matrix[0], &pVertex[j]);
			pVertexBuffer[j] = MultiplyMatrixVertex(&Matrix[1], &pVertexBuffer[j]);
			pVertexBuffer[j] = MultiplyMatrixVertex(&Matrix[2], &pVertexBuffer[j]);
			DivideVertexByW(&pVertexBuffer[j]);
		}
		DrawVertexIndexArrayXYZWUV(&Buffer.Bitmap, &ZBuffer, &Texture[1].Bitmap, pVertexBuffer, pIndex, IndexCount, VERTEX_CULL_NONE, &ColorKey);
		hOld = SelectObject(hSrcDC, Buffer.hBitmap);
		BitBlt(hDestDC, 0, 0, Buffer.Bitmap.Width, Buffer.Bitmap.Height, hSrcDC, 0, 0, SRCCOPY);
		SelectObject(hSrcDC, hOld);
	}
	Time[3][1] = timeGetTime();
	DestroyBitmapSharpBrain(&Buffer);
	DestroyBitmap16Any(&ZBuffer);
	DestroyBitmapSharpBrain(&Texture[0]);
	DestroyBitmapSharpBrain(&Texture[1]);
	delete []pVertex;
	delete []pIndex;
	delete []pVertexBuffer;
	ReleaseDC(hWnd, hDestDC);
	DeleteDC(hSrcDC);
	DestroyWindow(hWnd);
	_stprintf(Temp, _T("Buffer size : %ux%u px\nColor format : R5G6B5\nFill pixel x50 : %u ms\nTransfer buffer x100 : %u ms\nFill half pixel x100 : %u ms\nRender 3D scene x100 : %u ms"), Buffer.Bitmap.Width, Buffer.Bitmap.Height, Time[0][1] - Time[0][0], Time[1][1] - Time[1][0], Time[2][1] - Time[2][0], Time[3][1] - Time[3][0]);
	MessageBox(NULL, Temp, _T("Results"), MB_OK);
	return 0;
}

